/************************************************************************
 NestoRPi Engine
 Copyright (C) 2015-2025 Franck Talbart

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************************************/

/* Author: Franck Talbart */

/**
 * This module provides general utility functions
 */

#define _XOPEN_SOURCE

#include "src/core/util.hpp"

#include <ao/ao.h>
#include <ctype.h>
#include <errno.h>
#include <execinfo.h>
#include <fcntl.h>
#include <mpg123.h>
#include <pthread.h>
#include <sched.h>
#include <signal.h>
#include <sys/prctl.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include <cassert>
#include <filesystem>
#include <sstream>

#include "src/core/Log.hpp"
#include "src/core/const.hpp"
#include "src/core/debug.hpp"
#include "src/core/platform.hpp"
#include "src/core/version.hpp"

//------------------------------------------------------------------------------
/**
 * @brief Returns the absolute path of a directory
 *
 * @param  dir: the directory
 * @return absolute path of the directory
 */
const std::string util::get_full_dir(const std::string &dir)
{
    std::string res = dir;
    if (const char *root_dir = std::getenv(NRPI_ROOT_DIR))
    {
        res = std::string(root_dir) + "/" + res;
    }
    else
    {
        // Do not use LOG to avoid the infinite loop
        std::cerr << "NRPI_ROOT_DIR env. variable not set" << std::endl;
        exit(2);
    }
    return res + "/";
}

//------------------------------------------------------------------------------
/**
 * @brief Returns the absolute path of a directory taken from the cfg file
 *
 * @return absolute path of the directory
 */
const std::string util::get_full_dir_from_cfg(const std::string &path)
{
    std::string res = util::get_cfg_value(path).toString();
    if (res.length() == 0)
    {
        // do not use LOG here because it is not necessaritly initialized
        std::cerr << path << " is empty in the config file." << std::endl;
        ;
        exit(2);
    }
    if (res[0] != '/')
        return get_full_dir(res);
    return res + "/";
}

//------------------------------------------------------------------------------
/**
 * @brief Returns the absolute path of the config dir
 *
 * @param dir: a subdirectory (optional)
 * @return absolute path of the config directory
 */
const std::string util::get_cfg_dir(const std::string &dir)
{
    char *cfg_dir = std::getenv(NRPI_CFG_DIR);
    std::string res = cfg_dir == nullptr ? get_full_dir(PATH_CFG) : std::string(cfg_dir);
    if (dir != "")
        res = res + "/" + dir;
    return res + "/";
}

//------------------------------------------------------------------------------
/**
 * @brief Return the current time
 *
 * @return Format of the time: yy_MM_dd_hh_mm
 */
const std::string util::get_time(void)
{
    time_t t = time(0); // get time now
    struct tm *now = localtime(&t);
    return std::to_string(now->tm_year + 1900) + "_" + std::to_string(now->tm_mon + 1) + "_" +
           std::to_string(now->tm_mday) + "_" + std::to_string(now->tm_hour) + "_" +
           std::to_string(now->tm_min) + "_" + std::to_string(now->tm_sec);
}

//------------------------------------------------------------------------------
/**
 * @brief Return the nestorRPi engine version
 *
 * @return the version
 */
const std::string util::get_version(void)
{
    const std::string result = std::string(NRPI_VERSION_MAJOR) + "." + NRPI_VERSION_MINOR + "." +
                               NRPI_VERSION_HOT_FIXES + "_" + NRPI_VERSION_BUILD_NUMBER + "_" +
                               NRPI_VERSION_CMT_ID;
    return result;
}

//------------------------------------------------------------------------------
/**
 * @brief Get the metric values generated by the modules
 *
 * @return the metrics in JSON format
 */
const Json::Value util::get_metrics(void)
{
    Json::Value result;
    std::string shm_path;
    static std::map<std::string, std::ifstream> files;
    try
    {
        shm_path = util::get_cfg_value(CONFIG_SHM_PATH).toString();
    }
    catch (const std::out_of_range &oor)
    {
        NRPI_LOG(ERROR) << "Some parameters are missing!";
        throw;
    }
    shm_path = shm_path + "/";
    for (const auto &file : std::filesystem::directory_iterator(shm_path))
    {
        std::string path = file.path().string();
        size_t n;
        if ((n = path.rfind(PREFIX_SHM, shm_path.length())) != std::string::npos)
        {
            std::string value = "";
            if (files.find(path) == files.end())
                // cppcheck-suppress stlFindInsert
                files[path] = std::ifstream(path);
            if (files[path].is_open())
            {
                files[path].clear();
                files[path].seekg(0);
                getline(files[path], value);
            }
            if (value == "")
            {
                result[path.substr(n + strlen(PREFIX_SHM))] = "";
            }
            else
            {
                result[path.substr(n + strlen(PREFIX_SHM))] = std::stof(value);
            }
        }
    }
    return result;
}

//------------------------------------------------------------------------------
/**
 * @brief Convert a string to the role type
 *
 * @param role: string to convert
 * @return the role type
 */
role_type util::str_to_role(const std::string &role)
{
    if (role == "forbidden")
    {
        return FORBIDDEN;
    }
    else if (role == "full")
    {
        return FULL;
    }
    else if (role == "minimal")
    {
        return MINIMAL;
    }
    else
    {
        return FORBIDDEN;
    }
}

//------------------------------------------------------------------------------
/**
 * @brief Check the credential
 *
 * @param user: the username to check
 * @param passwd: the hashed password to check
 * @return the associated role type
 * @exception: std::string
 *
 */
role_type util::login(const std::string &user, const std::string &passwd)
{
    const std::string path = get_cfg_dir() + std::string(FILENAME_CREDENTIALS);
    struct stat buffer;
    if (stat(path.c_str(), &buffer) != 0)
    {
        NRPI_LOG(ERROR) << "File not found: " << path.c_str();
        throw std::string("Credentials file not found");
    }

    std::shared_ptr<char> file_content = nullptr;
    try
    {
        file_content = prepare_file(path);
    }
    catch (const std::string &err)
    {
        NRPI_LOG(ERROR) << err;
        throw std::string("Can't open credentials file");
    }

    std::stringstream ss(file_content.get());
    std::string line;

    while (std::getline(ss, line, '\n'))
    {
        std::string tmp = line + CRED_DELIMITER;
        size_t pos = 0;
        std::vector<std::string> credentials;
        while ((pos = tmp.find(CRED_DELIMITER)) != std::string::npos)
        {
            credentials.push_back(tmp.substr(0, pos));
            tmp.erase(0, pos + strlen(CRED_DELIMITER));
        }
        if (credentials.at(0) == user)
        {
            if (credentials.at(1) == "" || passwd == credentials.at(1))
            {
                return str_to_role(credentials.at(2));
            }
        }
    }
    // User not found
    if (user == DEFAULT_USER)
        return FORBIDDEN;
    return login(DEFAULT_USER, "");
}

//------------------------------------------------------------------------------
/**
 * @brief Extended Popen used to get stdout AND stderr
 *
 * @return std out, stderr
 */
util::Popen util::extended_popen_read(const char *program)
{
    // remove SIG_IGN set by daemonize
    signal(SIGCHLD, SIG_DFL);
    int pdes_out[2];
    int pdes_err[2];
    pid_t pid;

    if (pipe(pdes_out) < 0)
        throw std::string("Error with pipe");

    if (pipe(pdes_err) < 0)
        throw std::string("Error with pipe");

    switch (pid = fork())
    {
        case -1: // Error
            for (const auto &i : {pdes_out[0], pdes_out[1], pdes_err[0], pdes_err[1]}) close(i);
            throw std::string("Error with pipe");
        case 0: // Child
        {
            // For some reasons, the fake dlclose freezes docker in the CI
            debug::disable_fake_syscalls();
            dup2(pdes_out[1], STDOUT_FILENO);
            dup2(pdes_err[1], STDERR_FILENO);

            for (const auto &i : {pdes_out[0], pdes_out[1], pdes_err[0], pdes_err[1]}) close(i);
            execl("/bin/sh", "sh", "-c", program, nullptr);
        }
    }

    // Father
    FILE *iop_out = fdopen(pdes_out[0], "r");
    FILE *iop_err = fdopen(pdes_err[0], "r");

    for (const auto &i : {pdes_out[1], pdes_err[1]}) close(i);
    int status;
    waitpid(pid, &status, 0);
    return {iop_out, iop_err, status};
}

//------------------------------------------------------------------------------
/**
 * @brief Daemonize the process
 *
 *
 */
void util::daemonize(void)
{
    pid_t pid = fork();

    if (pid < 0)
    {
        NRPI_LOG(ERROR) << "fork() failed!";
        exit(EXIT_FAILURE);
    }
    else if (pid > 0)
    {
        // Father: we exit so that init will adopt the child
        exit(EXIT_SUCCESS);
    }
    else if (setsid() < 0) // Child, session leader
    {
        // It's better to use _exit rather than exit in the child
        _exit(EXIT_FAILURE);
    }

    // We ignore the child signal to avoid zombie process
    signal(SIGCHLD, SIG_IGN);

    // 2nd fork, prevent the daemon from acquiring a tty.
    pid = fork();

    if (pid < 0)
    {
        NRPI_LOG(ERROR) << "fork() failed!";
        exit(EXIT_FAILURE);
    }
    else if (pid > 0)
    {
        // Father
        exit(EXIT_SUCCESS);
    }

    close(STDIN_FILENO);
    close(STDOUT_FILENO);
    close(STDERR_FILENO);
    if (open("/dev/null", O_RDONLY) == -1)
    {
        NRPI_LOG(ERROR) << "failed to reopen stdin while daemonising";
        exit(EXIT_FAILURE);
    }
    if (open("/dev/null", O_WRONLY) == -1)
    {
        NRPI_LOG(ERROR) << "failed to reopen stdout while daemonising";
        exit(EXIT_FAILURE);
    }
    if (open("/dev/null", O_RDWR) == -1)
    {
        NRPI_LOG(ERROR) << "failed to reopen stderr while daemonising";
        exit(EXIT_FAILURE);
    }
}

//------------------------------------------------------------------------------
/**
 * @brief Deletes all the whitespace occurences and eol in a given string.
 *
 * @param str: the string to trim
 * @return shared pointer of the new string
 */
static std::shared_ptr<char> xstrim(const char *str)
{
    assert(str != nullptr);
    const char *start = str;
    const char *end = strlen(str) + start - 1; // strnlen not necessary here

    while (start < end && (*start == ' ' || *start == '\n')) ++start;
    while (start < end && (*end == ' ' || *end == '\n')) end--;

    std::shared_ptr<char> result(xstrndup(start, end - start + 1), free);
    return result;
}

//------------------------------------------------------------------------------
/**
 * @brief Malloc wrapper.
 *
 * @param size: the size
 * @return void *value the malloc result
 */
void *util::xmalloc(size_t size)
{
    assert(size > 0);
    void *ptr = malloc(size);
    assert(ptr != nullptr);
    return ptr;
}

//------------------------------------------------------------------------------
/**
 * @brief Open a file and load its content.
 *        WARNING: use with small files only!
 *
 * @param filename: the path of the file
 *
 * @return content
 */
std::shared_ptr<char> util::prepare_file(const std::string &filename)
{
    FILE *fp = fopen(filename.c_str(), "rb");
    if (fp == nullptr)
    {
        NRPI_LOG(ERROR) << filename << " not found!" << std::endl;
        throw std::string("Cannot open the file");
    }

    fseek(fp, 0, SEEK_END);
    size_t size = (size_t)ftell(fp);
    fseek(fp, 0, SEEK_SET);

    char *input = static_cast<char *>(xmalloc(size + 1)); // +1 => \0

    if (fread(input, 1, size, fp) != size)
    {
        NRPI_LOG(ERROR) << "Error while reading the file " << filename << std::endl;
        free(input);
        input = nullptr;
        fclose(fp);
        throw std::string("Cannot read the file");
    }

    fclose(fp);
    input[size] = '\0'; // fread add no bit terminating by \0

    std::shared_ptr<char> res = xstrim(input);
    free(input);
    input = nullptr;
    return (res);
}

//------------------------------------------------------------------------------
/**
 * @brief Split and decode the message into tokens which can be parsed
 *
 * @param msg: the full message
 *
 * @return list of tokens
 */
std::vector<std::string> util::msg_to_tokens(const std::string &msg)
{
    std::string tmp = msg + COMM_DELIMITER;

    size_t pos = 0;
    std::vector<std::string> res;
    while ((pos = tmp.find(COMM_DELIMITER)) != std::string::npos)
    {
        res.push_back(tmp.substr(0, pos));
        tmp.erase(0, pos + strlen(COMM_DELIMITER));
    }
    return (res);
}

//------------------------------------------------------------------------------
/**
 * @brief Get the value of a key from a JSON config file. Throw an exception
 *        in case of parsing error or key not found
 *
 * @param key: the key
 * @param path: path to the config file, only for the first call
 *
 * @return the corresponding value
 */
gason::JsonValue util::get_cfg_value(const std::string &key, const std::string &path)
{
    // Read the config file only once
    static std::shared_ptr<char> file_content = prepare_file(path);
    static gason::JsonAllocator allocator;
    char *endptr;
    static gason::JsonValue root;
    static int status = gason::jsonParse(file_content.get(), &endptr, &root, allocator);

    // do not use LOG here because it is not necessaritly initialized
    if (status != gason::JSON_PARSE_OK)
    {
        throw std::string("Json: parsing error");
    }

    for (const auto &value : root)
    {
        if (std::string(value->key) == key)
            return value->value;
    }

    throw std::string("Key " + key + " not found in the config file.");
}

//------------------------------------------------------------------------------
/**
 * @brief Print a backtrace after a segfault.
 *
 * @param sig: the signal id
 *
 *
 */
void util::print_back_trace(int sig)
{
    NRPI_LOG(ERROR) << "Back trace, got signal " << sig << std::endl;
    void *array[32]; //  backtrace symbols
    size_t size;     // number of values stored
    char **strings;  // functions from the backtrace list
    size_t cnt;

    size = backtrace(array, 32);
    strings = backtrace_symbols(array, size);

    for (cnt = 0; cnt < size; ++cnt) NRPI_LOG(ERROR) << strings[cnt] << std::endl;

    NRPI_LOG(ERROR) << "Generating core dump ...";
    abort();
}

//------------------------------------------------------------------------------
/**
 * @brief Set up the process to generate a coredump in case of failure.
 *
 *
 */
// cppcheck-suppress unusedFunction
void util::setup_coredump(void)
{
#ifdef __linux
    prctl(PR_SET_DUMPABLE, 1, 0, 0, 0);
    int prctl_rc = prctl(PR_GET_DUMPABLE, 0, 0, 0, 0);
    if (prctl_rc == 0)
        NRPI_LOG(ERROR) << "Failed to enable core dump for the current thread.";
    struct rlimit core_limits;
    core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
    if (setrlimit(RLIMIT_CORE, &core_limits) < 0)
        NRPI_LOG(ERROR) << "Failed to set core dump size. " << strerror(errno);
#endif
}

//------------------------------------------------------------------------------
/**
 * @brief Float to string convertor + keep 2 decimals
 *
 * @param val: the val to convert
 * @return the string convertion
 */
std::string util::float_to_str(const float val)
{
    std::ostringstream out;
    out.precision(2);
    out << std::fixed << val;
    return out.str();
}

//------------------------------------------------------------------------------
/**
 * @brief Play a MP3 sound
 *
 * @param filename: the MP3 filename
 *
 */
void util::play_sound(const std::string &filename)
{
    static std::mutex lock;
    lock.lock();
    mpg123_handle *mh;
    const short bits = 8;
    size_t buffer_size;
    size_t done;
    int err;

    int driver;
    ao_device *dev;

    ao_sample_format format;
    int channels, encoding;
    long rate;

    ao_initialize();
    driver = ao_default_driver_id();
    mpg123_init();
    mh = mpg123_new(nullptr, &err);
    buffer_size = mpg123_outblock(mh);

    auto buffer = std::unique_ptr<unsigned char, decltype(free) *>{
        reinterpret_cast<unsigned char *>(xmalloc(buffer_size * sizeof(unsigned char))), free};

    // Open the file and get the decoding format
    mpg123_open(mh, filename.c_str());
    mpg123_getformat(mh, &rate, &channels, &encoding);

    // Set the output format and open the output device
    format.bits = mpg123_encsize(encoding) * bits;
    format.rate = rate;
    format.channels = channels;
    format.byte_format = AO_FMT_NATIVE;
    format.matrix = 0;
    dev = ao_open_live(driver, &format, nullptr);

    // Decode and play
    while (mpg123_read(mh, buffer.get(), buffer_size, &done) == MPG123_OK)
        ao_play(dev, reinterpret_cast<char *>(buffer.get()), done);

    ao_close(dev);
    mpg123_close(mh);
    mpg123_delete(mh);
    mpg123_exit();
    ao_shutdown();
    lock.unlock();
}

//------------------------------------------------------------------------------
/**
 * @brief Set the current thread to high priority
 */
void util::set_thread_high_priority(pthread_t thread)
{
    struct sched_param params;
    params.sched_priority = sched_get_priority_max(SCHED_FIFO);

    if (pthread_setschedparam(thread, SCHED_FIFO, &params) != 0)
    {
        NRPI_LOG(ERROR) << "Can't define the thread priority.";
    }
}
